' a main menu type derived from AppModule
Type mainMenu Extends AppModule

	Field background:MasterSprite
	
	Field titlex:Int = 260
	Field titley:Int
	
	Function Create:mainMenu(resFile:String = "")
		Local mm:mainMenu = New mainMenu
		mm.Initialise( resFile, APP_MAINMENU )
		Return mm
	End Function 
	
	Method Start()
		Super.Start()
		background = GetSprite("background")

		If UserName() = Null Or UserName().Length = 0
			SetUserName("Player1")
		End If
		PlayGlobalSong("title")
		SetFadeColor( 0,0,0 )
		StartFadeIn()
		ShowMouse()
	End Method 
	
	Method FadeInComplete()
		GuiSetControlCaptionText("menu", "username", "Player: " + UserName())
		GuiShowWindow("menu")
	End Method
	
	Method FadeOutComplete()
		EndModule()
	End Method 
	
	Method Draw()
		background.Draw()
		DrawGUI()
		SetColor(0, 0, 0)
		GuiDrawText(VERSION_STRING, 10, 570)
		SetColor(255, 255, 255)
		Super.Draw()
	End Method 
	
	Method Update( timeMS:Int )
		Super.Update(timeMS)

		' Handling button hits is as simple as this...
		If (GuiButtonHit("exit") Or KeyHit(KEY_ESCAPE))
		
			GuiHideWindow("menu")
			StartFadeOut()
			FadeOutMusic()
			
		Else If ( GuiButtonHit( "start" ) )
		
			GuiHideWindow( "menu" )
			StartFadeOut()
			FadeOutMusic()
			HideMouse()
			game.Create( "Media/gameResources.txt" )
			
		Else If ( GuiButtonHit( "options" ) )
		
			PlaySoundByName( "swish" )
			SetVolumeSliderPosition( "options" , "music_volume" , GetMusicVolume() )
			SetVolumeSliderPosition( "options" , "sound_volume" , GetSoundVolume() )
			UpdateFullScreenButton( "options", "toggle_fullscreen" )
			GuiHideWindow("menu")
			GuiShowWindow( "options" )
			
		Else If ( GuiButtonHit( "login" ) )
		
			PlaySoundByName( "swish" )
			GuiHideWindow( "menu" )
			GuiShowWindow( "login" )
			
		Else If ( GuiButtonHit( "login_ok" ) )
		
			AddNewUser(GuiGetControlCaptionText("login", "login_name")) ' +++++ NEW! +++++
			GuiSetControlCaptionText("menu", "username", "Player: " + UserName())
			PlaySoundByName( "swish" )
			GuiHideWindow( "login" )
			GuiShowWindow( "menu" )
			
		Else If (GuiButtonHit("howtoplay"))
		
			PlaySoundByName( "swish" )
			GuiHideWindow( "menu" )
			GuiShowWindow("howtoplay")
			
		Else If (GuiButtonHit("howtoplay_ok"))
		
			PlaySoundByName( "swish" )
			GuiHideWindow("howtoplay")
			GuiShowWindow( "menu" )

		Else If (GuiButtonHit("credits"))
		
			PlaySoundByName( "swish" )
			GuiHideWindow( "menu" )
			GuiShowWindow("credits")
			
		Else If (GuiButtonHit("credits_ok"))
		
			PlaySoundByName( "swish" )
			GuiHideWindow("credits")
			GuiShowWindow("menu")

		Else If (GuiButtonHit("highscores"))
		
			For Local t:Int = 0 To 9
				Local score$ = GetHighScoreName( 0, t ) + " .... " + GetHighScoreValue( 0, t )
				GuiSetControlCaptionText( "highscores", "score" + (t + 1), score$ )
			Next 
			
			PlaySoundByName( "swish" )
			GuiHideWindow( "menu" )
			GuiShowWindow("highscores")
			
		Else If ( GuiButtonHit( "options_ok" ) )
		
			PlaySoundByName( "swish" )
			UpdateFullscreenFromButton( "options", "toggle_fullscreen" )
			GuiHideWindow( "options" )
			GuiShowWindow( "menu" )
			
		Else If (GuiButtonHit("music_volume"))
		
			SetMusicVolume( GetVolumeSliderPosition( "options" , "music_volume" ) )
			
		Else If ( GuiButtonHit( "sound_volume" ) )
		
			SetSoundVolume( GetVolumeSliderPosition( "options" , "sound_volume" ) )
			
		Else If ( GuiButtonHit( "scores_ok" ) )
		
			PlaySoundByName( "swish" )
			GuiHideWindow( "highscores" )
			GuiShowWindow("menu")
			
		End If
		
	End Method 
		
End Type 
